var fluent = require("vows-fluent"),
	request = require("request"),
	Assertion = require("should").Assertion.prototype,
	Trait = require("traits").Trait,
	util = require("util"),
	Topic = fluent.Topic,
	Vow = fluent.Vow,
	defaults = {},
	test_uri = /^(GET|POST|PUT|HEAD|DELETE)(.*)/;

var create = function _create(trait) {
	return Object.create(Object.prototype, trait)
};

exports.Is = {
	get a() {
		return this;
	},
	"request": function _request(url) {
		this._parent.set(function _topic() {
			var cb = this.callback;
			defaults.server.factory(function _getServer(server) {
				var options = {};
				var match = url && url.match(test_uri);
				if (match) {
					options.method = match[1];
					options.uri = defaults.server.uri + match[2].substr(1);
				} else {
					options.uri = defaults.server.uri + uri	
				}
				request(options, function _handleRequest(err, res, body) {
					server.close();
					cb(err, res);
				});
			});
		});
		return this._parent.parent();
	},
	"property": function _property(name) {
		this._parent.set(function _topic(topic) {
			return topic[name];
		});
		return this._parent.parent();
	}
};

exports.Should = {
	get error() {
		s._obj = s._error
		this.ok();
		return this;
	},
	"header": function _header(name, val) {
		return this.property("headers").property(name, val);
	},
	"_exec": function __exec() {
		var s = create(Trait(Assertion));
		s.obj = this._obj;
		this._stack.forEach(function _each(val) {
			if (val.type === 'get') {
				s = s[val.key];
			} else {
				s = s[val.key].apply(s, val.args);
			}
		});
	}
};

["vow", "context", "parent", "batch", "suite"].forEach(function (key) {
	exports.Should[key] = function _parent() {
		var parent = this._parent.parent();
		return parent[key].apply(parent, arguments);
	};
});

Object.keys(Assertion).forEach(function _each(key) {
	if (!exports.Should.hasOwnProperty(key)) {
		var descriptor = Object.getOwnPropertyDescriptor(Assertion, key);
		var name = descriptor.get ? "get" : "value";
		descriptor[name] = function _descriptor() {
			this._stack.push({
				"type": name,
				"key": key,
				"args": arguments
			});
			return this;
		}
		Object.defineProperty(exports.Should, key, descriptor);
	}
});

exports.It = {
	get should() {
		var s = create(Trait(exports.Should));
		this._parent.set(function _set(err, value) {
			s._obj = value;
			s._error = err;
			s._exec();
		});
		s._stack = [];
		s._parent = this._parent;
		return s;
	}
}

Object.defineProperty(Topic, "is", {
	"set": function _set() {},
	"get": function _get() {
		var i = create(Trait(exports.Is));
		i._parent = this;
		return i;
	}
});

Object.defineProperty(Vow, "it", {
	"set": function _set() {},
	"get": function _get() {
		var i = create(Trait(exports.It));
		i._parent = this;
		return i;
	}
})

exports.config = function _init(obj) {
	Object.keys(obj).forEach(function _each(key) {
		defaults[key] = obj[key];
	});
};

Object.keys(fluent).forEach(function _each(key) {
	exports[key] = fluent[key];
});